/*
** ARGOBOT
** Jess Cea Avin - jcea@argo.es
**
** 07/Abr/97 Versin 0.0. Hace las k-lines temporales.
** 08/Abr/97 Algunos includes extra para evitar warnings.
** 09/Abr/97 No requiere residir en la misma mquina que el server.
**           Gracias a Botito y Crazy por las pruebas, a Dani por
**           el entusiasmo y a Savage por apuntar en la direccin correcta.
** 
** 17/Abr/97 Versin 1.0. Primera versin oficial.
**           Si el server se cae, espera unos segundos y reintenta.
**           Trata los bfferes con mucho cuidado para evitar que se pueda
**           dar de alta una lnea K esprea (posible Denial Of Service).
**           Mucho ms depurado en la gestin de errores.
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <errno.h>

enum status_t {REGISTRO,PING,IDLE,RESTART};

typedef enum status_t status;

#define IRCop_clave	"********"
#define IRCop_nick	"ArgoBot"
#define IRCop_servidor	"irc.argo.es"
#define IRCop_puerto	6667
#define IRCop_kill	"*** Notice -- Received KILL message for" /* No tocar */
#define IRCop_kill_serv	"theilax.arrakis.es"	/* No tocar */

/*
** Segn el compilador, puede ser preciso
** unir las dos lneas siguientes en una sola.
*/
#define IRCop_away	"Bot de control de irc.argo.es. Para cualquier "\
			"consulta, hablar con jcea o mail a irc@argo.es"

#define IRCop_collide	"Escoge otro Nick, por favor"

/* No tocar */
#define Texto_klines	"Lnea K automatizada y temporal. Se elimina a las "

#define TIMEOUT_WHOWAS	30	/* No tocar */
#define TIMEOUT_KLINES	(60*60)	/* En segundos */
#define UMBRAL_KLINE	10	/* Nmero de respuestas al WHOWAS para k-line */
#define MAX_KLINES	500	/* Nmero mximo de klines temporales */

#define BUF_LEN	512	/* No tocar */

char klines[BUF_LEN*MAX_KLINES];
int num_klines=0;

struct {
	char remitente[BUF_LEN];
	char comando[BUF_LEN];
	char destinatario[BUF_LEN];
	char parametros[BUF_LEN];
} mensaje;

int soc;
time_t time_out;

char *copia_campo(char *destino,char *origen);
status interprete(status mode);
void invierte_destinos(void);
void envia_msg(void);
status ping(status mode);
status notice(status mode);
void define_kline(char *whowas);

/*
** Escribe una Lnea K en el fichero ircd.conf, si no la tenemos
** ya, y hace un /rehash en el servidor.
*/
void define_kline (char *whowas)
{
char *p=klines;
int i=num_klines;
int f;

/* Vamos a ver si ya la tenemos... */
	while(i) {
		if(!strcmp(p,whowas)) {
			printf("***\n*** Ya tenemos a %s como "
				"Lnea K temporal\n***\n",whowas);
			return;
		}
		i--;
		p=p+strlen(p)+1;	/* Busca la siguiente */
	}
/* Si estamos a tope, no hace nada */
	if(num_klines>=MAX_KLINES) {
		printf("***\n*** Lneas K temporales al completo (%d)\n***/n",
			num_klines);
		return;
	}

/* Tenemos que aadirla al fichero ircd.conf */
	f=open("ircd.conf",O_APPEND|O_WRONLY);
	if(f==-1) {	/* error */
		printf("***\n*** Error al intentar aadir a %s a nuestras "
			"Lneas K temporales",whowas);
		perror("*** ");
		printf("***\n");
		return;
	}
	write(f,"K:",2);
	write(f,whowas,strlen(whowas));
	write(f,":"Texto_klines,1+strlen(Texto_klines));
	{
	char buf[256];	/* 26 bytes segn el manual */
	
		strcpy(buf,ctime(&time_out));	/* Hora de cancelacin */
		buf[13]=';';
		buf[16]=';';
		write(f,buf+11,8);
	}
	write(f,":*\n",3);
	perror("*** ");
	close(f);
/* La aadimos a nuestra lista interna */
	strcpy(p,whowas);
	num_klines++;
	printf("***\n*** Aadido %s a nuestras Lneas K temporales.\n"
		"*** Informo de los cambios a %s.\n***\n",whowas,IRCop_servidor);
	mensaje.remitente[0]=mensaje.destinatario[0]=
		mensaje.parametros[0]='\0';
	strcpy(mensaje.comando,"rehash");	/* Rehash en servidor */
	envia_msg();
}

/*
** Pues eso... El Main :).
*/
int main(void)
{
struct hostent *servidor;
int estado;
struct sockaddr_in conexion;
status mode;
enum {OK,OVERFLOW} flag;
char buf[BUF_LEN];
char *p,*p2;

	num_klines=time_out=0;
	system("cp -p ircd.conf ircd.conf.old");
	system("cp -p ircd.conf.real ircd.conf");

inicio:

	printf("***\n*** INICIANDO...\n***\n");
	soc=socket(AF_INET,SOCK_STREAM,0);
	if(soc==-1) {
		perror("No se puede abrir el socket");
		exit(errno);
	}
	servidor=gethostbyname(IRCop_servidor);
	if(servidor==NULL) {
		perror("No se puede resolver el nombre del servidor");
		exit(errno);
	}
	
	conexion.sin_family=AF_INET;
	conexion.sin_addr=*(struct in_addr *)servidor->h_addr;
	conexion.sin_port=htons(IRCop_puerto);
	estado=connect(soc,(struct sockaddr *)&conexion,sizeof(conexion));
	if(estado==-1) {
		perror("Error en la conexin con el server. Reintentando...");
		close(soc);
		sleep(5);
		goto inicio;
	}
	mode=REGISTRO;
	
	while(!0) {	/* Bucle principal */

	if(time_out<=time(NULL)) { /* Ha llegado la hora de purgar Lneas K */
		printf("***\n*** Purgamos las Lneas K temporales\n***\n");
		system("cp -p ircd.conf.real ircd.conf");
		num_klines=0;
		time_out=time(NULL)+TIMEOUT_KLINES;
		mensaje.remitente[0]=mensaje.destinatario[0]=
			mensaje.parametros[0]='\0';
		strcpy(mensaje.comando,"rehash");
		envia_msg();
	}
	
	switch(mode) {
	case RESTART:
		goto inicio;
		break;
	case REGISTRO:	/* Registro inicial */
		strcpy(buf,"nick ");
		srand(time(NULL));	/* Generador de nmeros aleatorios */
		buf[5]=(char)((rand()%26)+'a');	/* Para evitar nick collide */
		buf[6]=(char)((rand()%26)+'a');
		buf[7]=(char)((rand()%26)+'a');
		buf[8]=(char)((rand()%26)+'a');
		buf[9]=(char)((rand()%26)+'a');
		buf[10]=(char)((rand()%26)+'a');
		buf[11]=(char)((rand()%26)+'a');
		buf[12]=(char)((rand()%26)+'a');
		buf[13]=(char)((rand()%26)+'a');
		buf[14]=(char)((rand()%26)+'a');
		buf[15]=(char)((rand()%26)+'a');
		buf[16]=(char)((rand()%26)+'a');
		buf[17]='\0';
		strcat(buf,"\nuser ");	/* Se registra */
		strcat(buf,IRCop_nick);
		strcat(buf," ");
		strcat(buf,IRCop_nick);
		strcat(buf," ");
		strcat(buf,IRCop_nick);
		strcat(buf," ");
		strcat(buf,IRCop_nick);
		strcat(buf,"\n");
		write(soc,buf,strlen(buf));
		mode=PING;
		p=buf;
		flag=OK;
		break;
	case IDLE:
	case PING:
		estado=read(soc,p,1);
		if(!estado) {	/* Nos cierran la conexin pero insistimos */
			close(soc);
			goto inicio;
		}
		if(p-buf>=BUF_LEN-3) { /* El tres es para curarnos en salud */
			flag=OVERFLOW;
		/*
		** Si es el final de comando, permite que se
		** escriba para ignorarlo despus. De esta forma se evita
		** que un enemigo enve mensajes que se descarten junto 
		** con la siguiente respuesta del servidor.
		*/
			if(*p!='\n') {
				p=buf;
				break;	/* Ignora ese texto */
			}
		}
		
		*(p+estado)='\0';
	/* Elimina los CR */
		while((p=(char *)strchr(buf,'\r'))!=NULL) strcpy(p,p+1);		
		p=(char *)strchr(buf,'\n');		
		if(p==NULL) {	/* Espera por el resto del comando */
			p=buf+strlen(buf);
			break;
		}
		
		if(flag==OVERFLOW) {	/* Ignora el texto */
			printf("***\n*** OVERFLOW\n***\n");
			p=buf;
			flag=OK;
			break;
		}
		*p='\0';
		printf("%s\n",buf);
		mensaje.remitente[0]=mensaje.comando[0]=
			mensaje.destinatario[0]=mensaje.parametros[0]='\0';
		p2=buf;
		if(buf[0]==':') p2=copia_campo(mensaje.remitente,p2);
		p2=copia_campo(mensaje.comando,p2);
		if(*p2!=':') p2=copia_campo(mensaje.destinatario,p2);
		strcpy(mensaje.parametros,p2);
		
		mode=interprete(mode);
		
		strcpy(buf,p+1);
		p=buf+strlen(buf);
		break;
	default:
		break;
		
	}
	}
	
	return 0;
}

/*
** Copia hasta que se llegue a un espacio o al final de la cadena.
** Devuelve el puntero al carcter tras el espacio o al '\0' final.
*/
char *copia_campo(char *destino,char *origen)
{
char *p;

	p=(char *)strchr(origen,' ');
	if(p==NULL) {
		strcpy(destino,origen);
		return origen+strlen(origen);
	}
	*p='\0';
	strcpy(destino,origen);
	*p=' ';
	return p+1;
}

/* 
** Invierte el origen y el destino del msg
*/
void invierte_destinos(void)
{
char buf[BUF_LEN];

	strcpy(buf,mensaje.remitente);
	strcpy(mensaje.remitente,mensaje.destinatario);
	strcpy(mensaje.destinatario,buf);
}

/*
** Construye un mensaje y lo enva
*/
void envia_msg(void)
{
char buf[4*BUF_LEN];

	buf[0]='\0';
	if(mensaje.remitente[0]) {
		strcpy(buf,mensaje.remitente);
		strcat(buf," ");
	}
	strcat(buf,mensaje.comando);
	strcat(buf," ");
	if(mensaje.destinatario[0]) {
		strcat(buf,mensaje.destinatario);
		strcat(buf," ");
	}
	strcat(buf,mensaje.parametros);
	strcat(buf,"\n");
	write(soc,buf,strlen(buf));
	printf(">>> %s",buf);
}

/* 
** Interprete de comandos
** Devuelve el nuevo modo al que debemos pasar
*/
status interprete(status mode)
{
char *comando=mensaje.comando;
static int insistencia=0;
static char whowas[BUF_LEN];

	invierte_destinos();
	
	if(!strcmp(comando,"ERROR") || !comando[0]) {
		close(soc);
		return RESTART;
	}
	if(!strcmp(comando,"NOTICE")) return notice(mode);
	if(!strcmp(comando,"PING")) return ping(mode);
	if(!strcmp(comando,"314")) {	/* Respuesta Whowas */
		if(!(insistencia++))	/* Buscamos la IP */
			copia_campo(whowas,copia_campo(whowas,
				copia_campo(whowas,mensaje.parametros)));
		return mode;
	}
	if(!strcmp(comando,"369")) {	/* Fin del Whowas */
		printf("***\n*** %s\n"
			"*** %d Accesos, de un mximo de %d"
			"\n***\n",whowas,insistencia,UMBRAL_KLINE);
		if(insistencia>UMBRAL_KLINE) define_kline(whowas);
		insistencia=0;
		return mode;
	}
	if(!strcmp(comando,"433")) {	/* Un nick collide en segunda fase */
		mensaje.remitente[0]='\0';
		strcpy(mensaje.comando,"kill");
		strcpy(mensaje.destinatario,IRCop_nick);
		strcpy(mensaje.parametros,":"IRCop_collide);
		envia_msg();
		strcpy(mensaje.comando,"nick");
		mensaje.parametros[0]='\0';
		envia_msg();
		sleep(5);
		return mode;
	}
	if(!strcmp(comando,"KICK")) {	/* Vuelve a entrar en el canal */
		strcpy(mensaje.destinatario,mensaje.remitente);
		mensaje.remitente[0]='\0';
		strcpy(mensaje.comando,"join");
		strcpy(mensaje.parametros,":GOD");
		envia_msg();
		return mode;
	}

	return mode;
}

/*
** Ante un notice, comprueba si es un kill de theilax. En ese caso se prepara
** el recuento del /whowas
*/

status notice(status mode)
{
char buf[BUF_LEN];
static time_t tiempo=0;
time_t t;
	
/* Mira si es un mensaje enviado por nuestro servidor */
	if(strcmp(mensaje.destinatario+1,IRCop_servidor)) return mode;
	strcpy(buf,mensaje.parametros);
	buf[strlen(IRCop_kill)+1]='\0';	/* el +1 es por los ":" iniciales */
/* Mira si es un KILL. Nos saltamos los ":" iniciales */
	if(strcmp(buf+1,IRCop_kill)) return mode;
	t=time(NULL);
/* Mira si es de theilax */
	strcpy(buf,". From ");
	strcat(buf,IRCop_kill_serv);
	strcat(buf," Path: ");
	if(strstr(mensaje.parametros,buf)==NULL) return mode;
/*
** Es un kill de theilax. Lo siguiente es para no hacer muchos Whowas
*/
	if(t-tiempo<TIMEOUT_WHOWAS) return mode;
	tiempo=t;
/*
** Obtenermos el nick a buscar.
** El +2 es por los ":" iniciales y el espacio final
*/
	copia_campo(buf,mensaje.parametros+strlen(IRCop_kill)+2);

	buf[strlen(buf)-1]='\0';
	mensaje.remitente[0]=mensaje.parametros[0]='\0';
	strcpy(mensaje.comando,"whowas");
	strcpy(mensaje.destinatario,buf);
	envia_msg();
	return mode;	
}

/*
** Resuelve el ping inicial. Pasa a modo operador, away, killea
** un posible nick collide y entra en opers.
*/
status ping(status mode)
{
	mensaje.comando[1]='O';
	envia_msg();
	if(mode==PING) {
	char buf[BUF_LEN];
	
		strcpy(buf,"oper ");
		strcat(buf,IRCop_nick);
		strcat(buf," ");
		strcat(buf,IRCop_clave);
		strcat(buf,"\n");
		strcat(buf,"kill ");
		strcat(buf,IRCop_nick);
		strcat(buf," :"IRCop_collide"\n");
		strcat(buf,"nick ");
		strcat(buf,IRCop_nick);
		strcat(buf,"\njoin #opers GOD\n");
		strcat(buf,"\naway :"IRCop_away"\n");
		write(soc,buf,strlen(buf));
		mode=IDLE;
	}
	return mode;
}
